1#!/bin/sh
2#
3# Copyright (c) 2004 - 2005 Kungliga Tekniska H�gskolan
4# (Royal Institute of Technology, Stockholm, Sweden). 
5# All rights reserved. 
6#
7# Redistribution and use in source and binary forms, with or without 
8# modification, are permitted provided that the following conditions 
9# are met: 
10#
11# 1. Redistributions of source code must retain the above copyright 
12#    notice, this list of conditions and the following disclaimer. 
13#
14# 2. Redistributions in binary form must reproduce the above copyright 
15#    notice, this list of conditions and the following disclaimer in the 
16#    documentation and/or other materials provided with the distribution. 
17#
18# 3. Neither the name of the Institute nor the names of its contributors 
19#    may be used to endorse or promote products derived from this software 
20#    without specific prior written permission. 
21#
22# THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND 
23# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
24# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
25# ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE 
26# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
27# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
28# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
29# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
30# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
31# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
32# SUCH DAMAGE. 
33#
34# $Id: test_nist.in 21787 2007-08-02 08:50:24Z lha $
35#
36
37srcdir="@srcdir@"
38objdir="@objdir@"
39nistdir=${objdir}/PKITS_data
40nistzip=${srcdir}/data/PKITS_data.zip
41
42limit="${1:-nolimit}"
43
44stat="--statistic-file=${objdir}/statfile"
45
46hxtool="${TESTS_ENVIRONMENT} ./hxtool ${stat}"
47
48# nistzip is not distributed part of the distribution
49test -f "$nistzip" || exit 77
50
51if ${hxtool} info | grep 'rsa: hcrypto null RSA' > /dev/null ; then
52    exit 77
53fi
54if ${hxtool} info | grep 'rand: not available' > /dev/null ; then
55    exit 77
56fi
57
58echo "nist tests, version 2"
59
60if [ ! -d "$nistdir" ] ; then
61    ( mkdir "$nistdir" && unzip -d "${nistdir}" "${nistzip}" ) >/dev/null || \
62	{ rm -rf "$nistdir" ; exit 1; }
63fi
64
65ec=
66name=
67description=
68while read result cert other ; do
69    if expr "$result" : "#" > /dev/null; then
70	name=${cert}
71	description="${other}"
72	continue
73    fi
74    
75    test nolimit != "${limit}" && ! expr "$name" : "$limit" > /dev/null && continue
76
77    test "$result" = "end" && break
78
79    args=
80    args="$args cert:FILE:$nistdir/certs/$cert"
81    args="$args chain:DIR:$nistdir/certs"
82    args="$args anchor:FILE:$nistdir/certs/TrustAnchorRootCertificate.crt"
83#    args="$args crl:FILE:$nistdir/crls/TrustAnchorRootCRL.crl"
84
85    for a in $nistdir/crls/*.crl; do
86	args="$args crl:FILE:$a"
87    done
88
89    cmd="${hxtool} verify $args"
90    eval ${cmd} > /dev/null
91    res=$?
92
93    case "${result},${res}" in
94    0,0) r="PASSs";;
95    0,*) r="FAILs";;
96    [123],0) r="FAILf";;
97    [123],*) r="PASSf";;
98    *) echo="unknown result ${result},${res}" ; exit 1 ;;
99    esac
100    if grep "${name} FAIL" $srcdir/data/nist-result2 > /dev/null; then
101	if expr "$r" : "PASS" >/dev/null; then
102	    echo "${name} passed when expected not to"
103	    echo "# ${description}" > nist2-passed-${name}.tmp
104	    ec=1
105	fi
106    elif expr "$r" : "FAIL.*" >/dev/null ; then
107	echo "$r ${name} ${description}"
108	echo "# ${description}" > nist2-failed-${name}.tmp
109	echo "$cmd" >> nist2-failed-${name}.tmp
110	ec=1
111    fi
112
113done < $srcdir/data/nist-data2
114
115
116echo "done!"
117
118exit $ec
119